#!/usr/bin/perl
use strict;
use Time::HiRes;

#Usage ./plot.pl -i <interface> -t <time in sec>
#Usage ./plot.pl -i eth0 -t 1

my $TIME = -1;
my $INTERFACE = "";
my $counter = 0;
my $OUTFILE = "data.txt";

sub parseFile {
my @resList = qx(cat /proc/net/dev);
my @line = grep(/^(\s*)$INTERFACE(.+)/,@resList);
if(not @line) {
	print "Interface not found\n";
	exit;
}
if(not (@line[0] =~ m/\s*$INTERFACE:\s*\d+\s+(\d+)\s+\d+\s+\d+\s+\d+\s+\d+\s+\d+\s+\d+\s+\d+\s+(\d+)(.*)/)) {
	print "Failed to get information from the proc file system\n";
	exit;
}
return($1,$2);
}

sub plot{
my ($prevRecvd, $prevSent) = parseFile;
#($currRecvd, $currSent); 
while(1) {
my ($secs1, $microsecs1) = Time::HiRes::gettimeofday;
my($currRecvd, $currSent) = parseFile;
print "Received: ",($currRecvd - $prevRecvd)," Sent: ",($currSent - $prevSent),"\n";

open(OUT,">>$OUTFILE");
print OUT "$counter ",($currRecvd-$prevRecvd),"\n";
close OUT;
$counter++;
$prevRecvd = $currRecvd;
$prevSent = $currSent;

my ($secs2, $microsecs2) = Time::HiRes::gettimeofday;
my $elapsedUSecs = ($secs2-$secs1) * 1000000 +(($microsecs2 - $microsecs1));
#print "Time taken is $elapsedUSecs Usecs. Sleep time: ",($TIME - $elapsedUSecs),"\n";
Time::HiRes::usleep($TIME - $elapsedUSecs);
}
}#EOS

sub usage {
	print "USAGE: ./plot.pl -t <timeinsecs> -i <interfacename>\n";
}

sub parseArgs {
my $cmdLine;

while(@ARGV)
{
 $cmdLine = $cmdLine." ".shift @ARGV;
}

#print $cmdLine;

if($cmdLine =~ m/^\s+-t\s+(\d+)\s+-i\s+(\w+)/) {
	 $TIME = $1;
	 $INTERFACE = $2;
}
elsif($cmdLine =~ m/^\s+-i\s+(\w+)\s+-t\s+(\d+)/) {
	 $TIME = $2;
	 $INTERFACE = $1;
}
else {
	usage;
	exit;
}
	$TIME *= 1000000;
}


# The main of the program
parseArgs;
plot;

